vs.2.0

//*********************************************************
// www.Ultimategameprogramming.com
// Basic Vertex Shader used with the D3DShader2 Demo
// Created by the Programming Ace.
//
// Input Registers used:
//   v0 - The vertex position (original).
//   v1 - The vertex color (original).
//   v2 - The vertex noraml (original).
//
// Output Registers used:
//   oPos - The vertex output position.
//   oD0  - The vertex output color.
//
// Constant Registers used:
//   c[0], c[1], c[2], c[3] - Model view projection matrix.
//   c[11] - Light Position.
//   c[15] - Light Color.
//
// Temporary Registers used:
//   r0, r1
//*********************************************************

dcl_position v0			// This is the vertex postion (x, y, z).
dcl_normal   v1			// This is the vertex normal.
dcl_color    v2			// This is the vertex color.


m4x4 r0, v0, c[0]       // This will translate the vertex by setting its new position.
dp3  r1, v1, c[11]      // Perform lighting N dot L calculation.

mov oPos, r0            // Set the final vertex output position into oPos.
mul r2, r1.x, c[15]     // Here we calculate the final diffuse color using the light color
                        // intensified by the dot product of the normal and the light position
                        // to make the triangle look shaded.

mul oD0, r2, v2         // Set final color.
